package sun.management.snmp.util;

import java.lang.ref.WeakReference;
import java.io.Serializable;

public abstract class SnmpTableCache implements Serializable
{
    protected long validity;
    protected transient WeakReference<SnmpCachedData> datas;
    
    public SnmpTableCache() {
    }
    
    protected boolean isObsolete(SnmpCachedData snmpCachedData) {
        return snmpCachedData == null || (this.validity >= 0L && System.currentTimeMillis() - snmpCachedData.lastUpdated > this.validity);
    }
    
    protected SnmpCachedData getCachedDatas() {
        if (this.datas == null) {
            return null;
        }
        SnmpCachedData snmpCachedData = (SnmpCachedData)this.datas.get();
        if (snmpCachedData == null || this.isObsolete(snmpCachedData)) {
            return null;
        }
        return snmpCachedData;
    }
    
    protected synchronized SnmpCachedData getTableDatas(Object o) {
        SnmpCachedData cachedDatas = this.getCachedDatas();
        if (cachedDatas != null) {
            return cachedDatas;
        }
        SnmpCachedData updateCachedDatas = this.updateCachedDatas(o);
        if (this.validity != 0L) {
            this.datas = new WeakReference(updateCachedDatas);
            return updateCachedDatas;
        }
        return updateCachedDatas;
    }
    
    protected abstract SnmpCachedData updateCachedDatas(Object p0);
    
    public abstract SnmpTableHandler getTableHandler();
}
